Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/conf_phys.F90	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/conf_phys.F90	(revision 1134)
@@ -1394,4 +1394,5 @@
   write(numout,*)' iflag_thermals_ed = ', iflag_thermals_ed
   write(numout,*)' iflag_thermals_optflux = ', iflag_thermals_optflux
+  write(numout,*)' iflag_clos = ', iflag_clos
   write(numout,*)' type_run = ',type_run 
   write(numout,*)' ok_isccp = ',ok_isccp 
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/cv3_inip.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/cv3_inip.F	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/cv3_inip.F	(revision 1134)
@@ -89,5 +89,6 @@
               aire=aire+(Qmix(ff+df) - Qmix(ff)) * (1.-ff)
               mu = mu + pdf * ff * df
-              write(*,*) pdf,  Qmix(ff), aire, ff
+         IF(prt_level>9)WRITE(lunout,*)                                 &
+     &               pdf,  Qmix(ff), aire, ff
          ff=ff+df
          enddo
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90	(revision 1134)
@@ -1054,4 +1054,6 @@
        IMPLICIT NONE
 
+       include 'iniprint.h'
+
        character(len=20)                :: nam_var
        integer, dimension(nfiles)      :: flag_var
@@ -1061,5 +1063,5 @@
         flag_var_omp = flag_var
         nam_var_omp = nam_var
-        print*,'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
+        IF(prt_level>10) WRITE(lunout,*)'Avant getin: nam_var flag_var ',nam_var,flag_var(:)
         call getin('flag_'//nam_var,flag_var_omp)
         flag_var = flag_var_omp
@@ -1067,5 +1069,5 @@
         nam_var=nam_var_omp
         
-        print*,'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
+        IF(prt_level>10) WRITE(lunout,*)'Apres getin: nam_var flag_var ',nam_var,flag_var(:)
 
       END SUBROUTINE conf_physoutputs
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F	(revision 1134)
@@ -2025,10 +2025,12 @@
        do i=1,klon
           if (alp(i)>alp_max) then
-             print*,'WARNING SUPER ALP (seuil=',alp_max,
+             IF(prt_level>9)WRITE(lunout,*)                             &
+     &       'WARNING SUPER ALP (seuil=',alp_max,
      ,       '): i, alp, alp_wake,ale',i,alp(i),alp_wake(i),ale(i)
              alp(i)=alp_max
           endif
           if (ale(i)>ale_max) then
-             print*,'WARNING SUPER ALE (seuil=',ale_max,
+             IF(prt_level>9)WRITE(lunout,*)                             &
+     &       'WARNING SUPER ALE (seuil=',ale_max,
      ,       '): i, alp, alp_wake,ale',i,ale(i),ale_wake(i),alp(i)
              ale(i)=ale_max
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_closure.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_closure.F90	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_closure.F90	(revision 1134)
@@ -55,5 +55,5 @@
 !            f(ig)=f(ig)+(f0(ig)-f(ig))*exp((-ptimestep/  &
 !    &                     zmax_sec(ig))*wmax_sec(ig))
-             print*,'closure dry',f(ig),wmax_sec(ig),alim_star_tot(ig),zmax_sec(ig)
+             if(prt_level.GE.10) write(lunout,*)'closure dry',f(ig),wmax_sec(ig),alim_star_tot(ig),zmax_sec(ig)
              else
              f(ig)=wmax(ig)*alim_star_tot(ig)/zdenom
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_dv2.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_dv2.F90	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_dv2.F90	(revision 1134)
@@ -54,5 +54,6 @@
       enddo
 
-      print*,'WARNING on initialise gamma(1:ngrid,1)=0.'
+      IF(prt_level>9)WRITE(lunout,*)                                    &
+     &      'WARNING on initialise gamma(1:ngrid,1)=0.'
       gamma(1:ngrid,1)=0.
       do k=2,nlay
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_main.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_main.F90	(revision 1133)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/thermcell_main.F90	(revision 1134)
@@ -232,5 +232,6 @@
 !     enddo 
 !    ENDIF !(1.eq.0) THEN
-     print*,'WARNING thermcell_main f0=max(f0,1.e-2)'
+     if (prt_level.ge.10)write(lunout,*)                                &
+    &     'WARNING thermcell_main f0=max(f0,1.e-2)'
      do ig=1,klon
       if (prt_level.ge.20) then
@@ -295,5 +296,6 @@
 
 !IM
-      print*,'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
+     if (prt_level.ge.10)write(lunout,*)                                &
+    &    'WARNING thermcell_main rhobarz(:,1)=rho(:,1)'
       rhobarz(:,1)=rho(:,1)
 
@@ -624,5 +626,6 @@
       enddo      
       if (prt_level.ge.1) print*,'14d OK convect8'
-      print*,'WARNING thermcell_main wth2=0. si zw2 > 1.e-10'
+      if (prt_level.ge.10)write(lunout,*)                                &
+    &     'WARNING thermcell_main wth2=0. si zw2 > 1.e-10'
       do l=1,nlay
          do ig=1,ngrid