Index: LMDZ4/trunk/libf/phylmd/phys_output_write.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 1344)
+++ LMDZ4/trunk/libf/phylmd/phys_output_write.h	(revision 1345)
@@ -914,4 +914,5 @@
 ! OD550 per species
       IF (new_aod .and. (.not. aerosol_couple)) THEN
+          IF (ok_ade.OR.ok_aie) THEN
 
           IF (o_od550aer%flag(iff)<=lev_files(iff)) THEN
@@ -932,76 +933,77 @@
           ENDIF
 
-        IF (o_sconcso4%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_sconcso4%name,itau_w,
-     $       sconcso4)
-        ENDIF
-        IF (o_sconcoa%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_sconcoa%name,itau_w,
-     $       sconcoa)
-        ENDIF
-        IF (o_sconcbc%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_sconcbc%name,itau_w,
-     $       sconcbc)
-        ENDIF
-        IF (o_sconcss%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_sconcss%name,itau_w,
-     $       sconcss)
-        ENDIF
-        IF (o_sconcdust%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_sconcdust%name,itau_w,
-     $       sconcdust)
-        ENDIF
-
-        IF (o_concso4%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_concso4%name,itau_w,
-     $       concso4)
-        ENDIF
-        IF (o_concoa%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_concoa%name,itau_w,
-     $       concoa)
-        ENDIF
-        IF (o_concbc%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_concbc%name,itau_w,
-     $       concbc)
-        ENDIF
-        IF (o_concss%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_concss%name,itau_w,
-     $       concss)
-        ENDIF
-        IF (o_concdust%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_concdust%name,itau_w,
-     $       concdust)
-        ENDIF
-
-        IF (o_loadso4%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_loadso4%name,itau_w,
-     $       loadso4)
-        ENDIF
-        IF (o_loadoa%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_loadoa%name,itau_w,
-     $       loadoa)
-        ENDIF
-        IF (o_loadbc%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_loadbc%name,itau_w,
-     $       loadbc)
-        ENDIF
-        IF (o_loadss%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_loadss%name,itau_w,
-     $       loadss)
-        ENDIF
-        IF (o_loaddust%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_loaddust%name,itau_w,
-     $       loaddust)
-        ENDIF
-
-      DO naero = 1, naero_spc
-          IF (o_tausumaero(naero)%flag(iff)<=lev_files(iff)) THEN
-             CALL histwrite_phy(nid_files(iff),
-     $            o_tausumaero(naero)%name,itau_w,
-     $            tausum_aero(:,2,naero) )
-          ENDIF
-      END DO
-      ENDIF
-
+          IF (o_sconcso4%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_sconcso4%name,itau_w,
+     $            sconcso4)
+          ENDIF
+          IF (o_sconcoa%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_sconcoa%name,itau_w,
+     $            sconcoa)
+          ENDIF
+          IF (o_sconcbc%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_sconcbc%name,itau_w,
+     $            sconcbc)
+          ENDIF
+          IF (o_sconcss%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_sconcss%name,itau_w,
+     $            sconcss)
+          ENDIF
+          IF (o_sconcdust%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_sconcdust%name,itau_w,
+     $            sconcdust)
+          ENDIF
+          
+          IF (o_concso4%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_concso4%name,itau_w,
+     $            concso4)
+          ENDIF
+          IF (o_concoa%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_concoa%name,itau_w,
+     $            concoa)
+          ENDIF
+          IF (o_concbc%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_concbc%name,itau_w,
+     $            concbc)
+          ENDIF
+          IF (o_concss%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_concss%name,itau_w,
+     $            concss)
+          ENDIF
+          IF (o_concdust%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_concdust%name,itau_w,
+     $            concdust)
+          ENDIF
+          
+          IF (o_loadso4%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_loadso4%name,itau_w,
+     $            loadso4)
+          ENDIF
+          IF (o_loadoa%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_loadoa%name,itau_w,
+     $            loadoa)
+          ENDIF
+          IF (o_loadbc%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_loadbc%name,itau_w,
+     $            loadbc)
+          ENDIF
+          IF (o_loadss%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_loadss%name,itau_w,
+     $            loadss)
+          ENDIF
+          IF (o_loaddust%flag(iff)<=lev_files(iff)) THEN
+              CALL histwrite_phy(nid_files(iff),o_loaddust%name,itau_w,
+     $            loaddust)
+          ENDIF
+          
+          DO naero = 1, naero_spc
+            IF (o_tausumaero(naero)%flag(iff)<=lev_files(iff)) THEN
+                CALL histwrite_phy(nid_files(iff),
+     $              o_tausumaero(naero)%name,itau_w,
+     $              tausum_aero(:,2,naero) )
+            ENDIF
+          END DO
+          endif
+      ENDIF
+      
        IF (ok_ade) THEN
           IF (o_topswad%flag(iff)<=lev_files(iff)) THEN