Index: LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynredem.F
===================================================================
--- LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynredem.F	(revision 1299)
+++ LMDZ4/branches/LMDZ4V5.0-dev/libf/dyn3dpar/dynredem.F	(revision 1380)
@@ -8,4 +8,5 @@
 #endif
       USE infotrac
+ 
       IMPLICIT NONE
 c=======================================================================
@@ -25,4 +26,5 @@
 #include "description.h"
 #include "serre.h"
+#include "iniprint.h"
 
 c   Arguments:
@@ -72,9 +74,9 @@
        tab_cntrl(l) = 0.
       ENDDO
-       tab_cntrl(1)  =  REAL(iim)
-       tab_cntrl(2)  =  REAL(jjm)
-       tab_cntrl(3)  =  REAL(llm)
-       tab_cntrl(4)  =  REAL(day_ref)
-       tab_cntrl(5)  =  REAL(annee_ref)
+       tab_cntrl(1)  = REAL(iim)
+       tab_cntrl(2)  = REAL(jjm)
+       tab_cntrl(3)  = REAL(llm)
+       tab_cntrl(4)  = REAL(day_ref)
+       tab_cntrl(5)  = REAL(annee_ref)
        tab_cntrl(6)  = rad
        tab_cntrl(7)  = omeg
@@ -116,6 +118,6 @@
       ENDIF
 
-       tab_cntrl(30) =  REAL(iday_end)
-       tab_cntrl(31) =  REAL(itau_dyn + itaufin)
+       tab_cntrl(30) = REAL(iday_end)
+       tab_cntrl(31) = REAL(itau_dyn + itaufin)
 c
 c    .........................................................
@@ -125,6 +127,7 @@
       ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
       IF (ierr.NE.NF_NOERR) THEN
-         WRITE(6,*)" Pb d ouverture du fichier "//fichnom
-         WRITE(6,*)' ierr = ', ierr
+         write(lunout,*)"dynredem0: Pb d ouverture du fichier "
+     &                  //trim(fichnom)
+         write(lunout,*)' ierr = ', ierr
          CALL ABORT
       ENDIF
@@ -508,7 +511,8 @@
       ierr = NF_CLOSE(nid) ! fermer le fichier
 
-      PRINT*,'iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
-      PRINT*,'rad,omeg,g,cpp,kappa',
-     ,        rad,omeg,g,cpp,kappa
+      write(lunout,*)'dynredem0: iim,jjm,llm,iday_end',
+     &               iim,jjm,llm,iday_end
+      write(lunout,*)'dynredem0: rad,omeg,g,cpp,kappa',
+     &        rad,omeg,g,cpp,kappa
 
       RETURN
@@ -518,4 +522,5 @@
       USE infotrac
       USE control_mod
+ 
       IMPLICIT NONE
 c=================================================================
@@ -529,4 +534,6 @@
 #include "comgeom.h"
 #include "temps.h"
+#include "iniprint.h"
+
 
       INTEGER l
@@ -555,5 +562,5 @@
       ierr = NF_OPEN(fichnom, NF_WRITE, nid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Pb. d ouverture "//fichnom
+         write(lunout,*)"dynredem1: Pb. d ouverture "//trim(fichnom)
          CALL abort
       ENDIF
@@ -564,5 +571,5 @@
       ierr = NF_INQ_VARID(nid, "temps", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         print *, NF_STRERROR(ierr)
+         write(lunout,*) NF_STRERROR(ierr)
          abort_message='Variable temps n est pas definie'
          CALL abort_gcm(modname,abort_message,ierr)
@@ -573,5 +580,5 @@
       ierr = NF_PUT_VAR1_REAL (nid,nvarid,nb,time)
 #endif
-      PRINT*, "Enregistrement pour ", nb, time
+      write(lunout,*) "dynredem1: Enregistrement pour ", nb, time
 
 c
@@ -589,5 +596,5 @@
       ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
 #endif
-       tab_cntrl(31) =  REAL(itau_dyn + itaufin)
+       tab_cntrl(31) = REAL(itau_dyn + itaufin)
 #ifdef NC_DOUBLE
       ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
@@ -600,6 +607,7 @@
       ierr = NF_INQ_VARID(nid, "ucov", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Variable ucov n est pas definie"
-         CALL abort
+         abort_message="Variable ucov n est pas definie"
+         ierr=1
+         CALL abort_gcm(modname,abort_message,ierr)
       ENDIF
 #ifdef NC_DOUBLE
@@ -611,6 +619,7 @@
       ierr = NF_INQ_VARID(nid, "vcov", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Variable vcov n est pas definie"
-         CALL abort
+         abort_message="Variable vcov n est pas definie"
+         ierr=1
+         CALL abort_gcm(modname,abort_message,ierr)
       ENDIF
 #ifdef NC_DOUBLE
@@ -622,6 +631,7 @@
       ierr = NF_INQ_VARID(nid, "teta", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Variable teta n est pas definie"
-         CALL abort
+         abort_message="Variable teta n est pas definie"
+         ierr=1
+         CALL abort_gcm(modname,abort_message,ierr)
       ENDIF
 #ifdef NC_DOUBLE
@@ -635,6 +645,7 @@
          ierr_file = NF_OPEN ("start_trac.nc", NF_NOWRITE,nid_trac)
          IF (ierr_file .NE.NF_NOERR) THEN
-            write(6,*)' Pb d''ouverture du fichier start_trac.nc'
-            write(6,*)' ierr = ', ierr_file 
+            write(lunout,*)'dynredem1: Pb d''ouverture du fichier',
+     &                     ' start_trac.nc'
+            write(lunout,*)' ierr = ', ierr_file 
          ENDIF
       END IF
@@ -646,6 +657,7 @@
             ierr = NF_INQ_VARID(nid, tname(iq), nvarid)
             IF (ierr .NE. NF_NOERR) THEN
-               PRINT*, "Variable  tname(iq) n est pas definie"
-               CALL abort
+               abort_message="Variable  tname(iq) n est pas definie"
+               ierr=1
+               CALL abort_gcm(modname,abort_message,ierr)
             ENDIF
 #ifdef NC_DOUBLE
@@ -659,9 +671,12 @@
              ierr = NF_INQ_VARID (nid_trac, tname(iq), nvarid_trac)
              IF (ierr .NE. NF_NOERR) THEN
-                PRINT*, tname(iq),"est absent de start_trac.nc"
+                write(lunout,*) "dynredem1: ",trim(tname(iq)),
+     &                          " est absent de start_trac.nc"
                 ierr = NF_INQ_VARID(nid, tname(iq), nvarid)
                 IF (ierr .NE. NF_NOERR) THEN
-                   PRINT*, "Variable ", tname(iq)," n est pas definie"
-                   CALL abort
+                   abort_message="dynredem1: Variable "//
+     &                     trim(tname(iq))//" n est pas definie"
+                   ierr=1
+                   CALL abort_gcm(modname,abort_message,ierr)
                 ENDIF
 #ifdef NC_DOUBLE
@@ -672,5 +687,6 @@
                 
              ELSE
-                PRINT*, tname(iq), "est present dans start_trac.nc"
+                write(lunout,*) "dynredem1: ",trim(tname(iq)),
+     &              " est present dans start_trac.nc"
 #ifdef NC_DOUBLE
                ierr = NF_GET_VAR_DOUBLE(nid_trac, nvarid_trac, trac_tmp)
@@ -679,11 +695,15 @@
 #endif
                 IF (ierr .NE. NF_NOERR) THEN
-                   PRINT*, "Lecture echouee pour", tname(iq)
-                   CALL abort
+                   abort_message="dynredem1: Lecture echouee pour"//
+     &                    trim(tname(iq))
+                   ierr=1
+                   CALL abort_gcm(modname,abort_message,ierr)
                 ENDIF
                 ierr = NF_INQ_VARID(nid, tname(iq), nvarid)
                 IF (ierr .NE. NF_NOERR) THEN
-                   PRINT*, "Variable ", tname(iq)," n est pas definie"
-                   CALL abort
+                   abort_message="dynredem1: Variable "//
+     &                trim(tname(iq))//" n est pas definie"
+                   ierr=1
+                   CALL abort_gcm(modname,abort_message,ierr)
                 ENDIF
 #ifdef NC_DOUBLE
@@ -699,6 +719,8 @@
              ierr = NF_INQ_VARID(nid, tname(iq), nvarid)
              IF (ierr .NE. NF_NOERR) THEN
-                PRINT*, "Variable  tname(iq) n est pas definie"
-                CALL abort
+                abort_message="dynredem1: Variable "//
+     &                trim(tname(iq))//" n est pas definie"
+                   ierr=1
+                   CALL abort_gcm(modname,abort_message,ierr)
              ENDIF
 #ifdef NC_DOUBLE
@@ -715,6 +737,7 @@
       ierr = NF_INQ_VARID(nid, "masse", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Variable masse n est pas definie"
-         CALL abort
+         abort_message="dynredem1: Variable masse n est pas definie"
+         ierr=1
+         CALL abort_gcm(modname,abort_message,ierr)
       ENDIF
 #ifdef NC_DOUBLE
@@ -726,6 +749,7 @@
       ierr = NF_INQ_VARID(nid, "ps", nvarid)
       IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Variable ps n est pas definie"
-         CALL abort
+         abort_message="dynredem1: Variable ps n est pas definie"
+         ierr=1
+         CALL abort_gcm(modname,abort_message,ierr)
       ENDIF
 #ifdef NC_DOUBLE