Index: LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 1374)
+++ LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 1398)
@@ -27,7 +27,10 @@
      .                 nhori, nid_mthnmc)
 c
-         CALL histvert(nid_mthnmc, "plev", "pressure", "Pa",
-     .                 nlevSTD, rlevSTD, nvert)
-ccc
+         CALL histvert(nid_mthnmc, "plev", "pressure", "mb",
+     .                 nlevSTD, rlevSTD/100., nvert,"down")
+c
+cIM Astuce MAF: remplacer inst par ave pour les variables NMC pour avoir
+cIM             le time_counter et les bounds
+cIM 
 ccc Champs 3D interpolles sur des niveaux de pression du NMC
 ccc
@@ -44,50 +47,50 @@
      .                 "Valeurs non-definies","-",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "ta",
      .                 "Air temperature","K",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
          CALL histdef(nid_mthnmc, "zg",
      .                "Geopotential height", "m",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "hus",
      .                 "Specific humidity","1",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
          CALL histdef(nid_mthnmc, "hur",
      .                 "Relative humidity", "%",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "ua",
      .                 "Eastward wind","m s-1",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "va",
      .                 "Northward wind","m s-1",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "wap",
      .                 "Lagrangian tendency of air pressure","Pa s-1",
      .                iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .                "inst(X)", zout,zout)
+     .                "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "psbg",
      .         "Pressure sfce below ground","%",
      .         iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "uv",
      .         "uv ",
      .         "m2/s2",iim,jj_nb,nhori, nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "vq",
@@ -95,5 +98,5 @@
      .         "m/s * (kg/kg)",iim,jj_nb,nhori, 
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "vT",
@@ -101,5 +104,5 @@
      .         "mK/s",iim,jj_nb,nhori, 
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "wq",
@@ -107,5 +110,5 @@
      .         "(Pa/s)*(kg/kg)",iim,jj_nb,nhori,
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "vphi",
@@ -113,5 +116,5 @@
      .         "m2/s",iim,jj_nb,nhori, 
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "wT",
@@ -119,5 +122,5 @@
      .         "K*Pa/s",iim,jj_nb,nhori,
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "uxu",
@@ -125,5 +128,5 @@
      .         "m2/s2",iim,jj_nb,nhori,
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "vxv",
@@ -131,5 +134,5 @@
      .         "m2/s2",iim,jj_nb,nhori,
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
           CALL histdef(nid_mthnmc, "TxT",
@@ -137,7 +140,20 @@
      .         "K2",iim,jj_nb,nhori,
      .          nlevSTD,1,nlevSTD, nvert, 32,
-     .         "inst(X)", zout,zout)
+     .         "ave(X)", zout,zout)
 c
-
+          CALL histdef(nid_mthnmc, "tro3",
+     .         "Ozone mole fraction",
+     .         "1e-9",iim,jj_nb,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "ave(X)", zout,zout)
+c
+          if (read_climoz == 2) THEN
+           CALL histdef(nid_mthnmc, "tro3_daylight",
+     .         "Daylight ozone mole fraction",
+     .         "1e-9",iim,jj_nb,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "ave(X)", zout,zout)
+          endif
+c
          CALL histend(nid_mthnmc)
 c